"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = addImport;

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var importMap = new WeakMap();

function addImport(file, source, imported) {
  var imports = importMap.get(file);

  if (!imports) {
    imports = {};
    importMap.set(file, imports);
  }

  var alias = "".concat(source, ":").concat(imported);

  if (imports[alias]) {
    return t.cloneNode(imports[alias]);
  }

  var scope = file.scope;
  var id = scope.generateUidIdentifier(imported);
  imports[alias] = id;
  var specifier = t.importSpecifier(id, t.identifier(imported));
  var declaration = t.importDeclaration([specifier], t.stringLiteral(source));
  file.path.unshiftContainer("body", declaration);
  return t.cloneNode(id);
}