"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = flattenExpressions;

var _toStatement = _interopRequireDefault(require("./to-statement"));

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Helper to flatten out sequence expressions into a top level
// expression statements.
function flattenExpressions(expressions) {
  var nodes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return expressions.reduce(function (nodes, node) {
    if (t.isSequenceExpression(node)) {
      return flattenExpressions(node.expressions, nodes);
    }

    nodes.push((0, _toStatement["default"])(node));
    return nodes;
  }, nodes);
}