"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = toReference;

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Helper to transform a JSX identifier into a normal reference.
function toReference(node) {
  var identifier = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  if (typeof node === "string") {
    return node.split(".").map(function (s) {
      return t.identifier(s);
    }).reduce(function (obj, prop) {
      return t.memberExpression(obj, prop);
    });
  }

  if (t.isJSXIdentifier(node)) {
    return identifier ? t.identifier(node.name) : t.stringLiteral(node.name);
  }

  if (t.isJSXMemberExpression(node)) {
    return t.memberExpression(toReference(node.object, true), toReference(node.property, true));
  }

  return node;
}