"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = collectImports;

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var importDeclarationFinder = {
  ImportDeclaration: function ImportDeclaration(path) {
    var _path$node = path.node,
        specifiers = _path$node.specifiers,
        source = _path$node.source;
    var src = source.value;
    var imports = this.imports.find(function (imports) {
      return imports.source === src;
    });

    if (!imports) {
      imports = {
        source: src,
        imported: [],
        specifiers: []
      };
      this.imports.push(imports);
    }

    for (var i = 0; i < specifiers.length; i++) {
      var specifier = specifiers[i];
      var local = specifier.local.name;

      if (t.isImportDefaultSpecifier(specifier)) {
        imports.imported.push("default");
        imports.specifiers.push({
          kind: "named",
          imported: "default",
          local: local
        });
      } else if (t.isImportNamespaceSpecifier(specifier)) {
        imports.imported.push("*");
        imports.specifiers.push({
          kind: "namespace",
          local: local
        });
      } else {
        var imported = specifier.imported.name;
        imports.imported.push(imported);
        imports.specifiers.push({
          kind: "named",
          imported: imported,
          local: local
        });
      }
    }
  },
  ExpressionStatement: function ExpressionStatement(path) {
    path.skip();
  }
}; // Gathers the import statements in this file.

function collectImports(program) {
  var imports = [];
  program.traverse(importDeclarationFinder, {
    imports: imports
  });
  return imports;
}