"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = elementCloseCall;

var _toFunctionCall = _interopRequireDefault(require("./ast/to-function-call"));

var _toReference = _interopRequireDefault(require("./ast/to-reference"));

var _idomMethod = _interopRequireDefault(require("./idom-method"));

var _isComponent = _interopRequireDefault(require("./is-component"));

var _attributes = require("./attributes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Returns the closing element's function call.
function elementCloseCall(path, plugin) {
  var node = path.node;
  var attributes = path.get("attributes"); // Self closing elements that do not contain a SpreadAttribute will use `elementVoid`,
  // so the closing `elementClose` is not needed.

  if (node.selfClosing && !(0, _attributes.hasSpread)(attributes) && !(0, _attributes.hasSkip)(attributes, plugin)) {
    return null;
  }

  var name = path.get("name");
  var useReference = (0, _isComponent["default"])(name, plugin);
  return (0, _toFunctionCall["default"])((0, _idomMethod["default"])("elementClose", plugin), [(0, _toReference["default"])(name.node, useReference)]);
}