"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extractExpressions = _interopRequireDefault(require("./extract-expressions"));

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Take single use variable declarations and move them inside
// the JSX Expression Container where they are referenced.
var expressionInliner = {
  JSXExpressionContainer: function JSXExpressionContainer(path) {
    var expression = path.get("expression");

    if (!expression.isIdentifier()) {
      return;
    }

    var binding = path.scope.getBinding(expression.node.name);

    if (!binding || binding.references > 1 || !binding.constant) {
      return;
    }

    var declarator = binding.path;

    if (!declarator.isVariableDeclarator()) {
      return;
    }

    var init = declarator.get("init");

    if (!init.isJSXElement()) {
      return;
    }

    var closureVars = [];
    var state = Object.assign({}, this, {
      closureVarsStack: [closureVars]
    });
    init.traverse(_extractExpressions["default"], state);
    expression.replaceWith(init.node);
    declarator.replaceWithMultiple(closureVars.map(function (cv) {
      return t.variableDeclarator(cv.id, cv.init);
    }));
  }
};
var _default = expressionInliner;
exports["default"] = _default;