"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = isLiteralOrSpecial;
exports.isLiteralOrSpecialNode = isLiteralOrSpecialNode;

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Literals and `undefined` are treated as constant values in attributes and
// children.
function isLiteralOrSpecial(path) {
  return isLiteralOrSpecialNode(path.node);
}

function isLiteralOrSpecialNode(node) {
  if (t.isTemplateLiteral(node)) {
    return node.expressions.every(isLiteralOrSpecialNode);
  }

  return t.isLiteral(node) || t.isUnaryExpression(node, {
    operator: "void"
  }) || t.isIdentifier(node, {
    name: "undefined"
  }) || t.isIdentifier(node, {
    name: "NaN"
  }) || t.isIdentifier(node, {
    name: "Infinity"
  });
}