"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = moduleSource;

var _collectImports = _interopRequireDefault(require("./collect-imports"));

var _resolvePath = _interopRequireDefault(require("./resolve-path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Determines the import module source for iDOM.
function moduleSource(_ref) {
  var opts = _ref.opts,
      file = _ref.file;
  var moduleSource = opts.moduleSource;

  if (moduleSource) {
    return (0, _resolvePath["default"])(file.opts.filename, moduleSource);
  } // See if we can find the incremental-dom import.


  var imports = (0, _collectImports["default"])(file.path);
  var imported = imports.find(function (imported) {
    return imported.source === "incremental-dom";
  });

  if (imported) {
    return "incremental-dom";
  }
}