"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = injectRenderArbitrary;

var _inject = _interopRequireDefault(require("../inject"));

var _hasOwn = _interopRequireDefault(require("./has-own"));

var _toFunctionCall = _interopRequireDefault(require("../ast/to-function-call"));

var _idomMethod = _interopRequireDefault(require("../idom-method"));

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Isolated AST code to determine if a value is textual
// (strings and numbers).
function isTextual(type, value) {
  return t.logicalExpression("||", t.binaryExpression("===", type, t.stringLiteral("number")), t.logicalExpression("||", t.binaryExpression("===", type, t.stringLiteral("string")), t.logicalExpression("&&", t.binaryExpression("===", type, t.stringLiteral("object")), t.binaryExpression("instanceof", value, t.identifier("String")))));
} // Isolated AST code to determine if a value an Array.


function isArray(value) {
  return (0, _toFunctionCall["default"])(t.memberExpression(t.identifier("Array"), t.identifier("isArray")), [value]);
} // Isolated AST code to determine if a value an Object.


function isObject(type) {
  return t.binaryExpression("===", type, t.stringLiteral("object"));
} // Isolated AST code to determine if a value is a wrapped
// JSX element closure.


function isDOMWrapper(value) {
  return t.memberExpression(value, t.identifier("__jsxDOMWrapper"));
} // Isolated AST to determine if the value is a "plain" object.


function isPlainObject(value) {
  return t.binaryExpression("===", (0, _toFunctionCall["default"])(t.identifier("String"), [value]), t.stringLiteral("[object Object]"));
} // Renders an arbitrary JSX Expression into the DOM.
// Valid types are strings, numbers, and JSX element closures.
// It may also be an Array or Object, which will be iterated
// recursively to find a valid type.


function renderArbitraryAST(plugin, ref, deps) {
  var hasOwn = deps.hasOwn;
  var child = t.identifier("child");
  var type = t.identifier("type");
  var func = t.identifier("func");
  var args = t.identifier("args");
  var i = t.identifier("i");
  var prop = t.identifier("prop");
  /**
   * function _renderArbitrary(child) {
   *   var type = typeof child;
   *   if (type === "number" || (type === string || type === 'object' && child instanceof String)) {
   *     text(child);
   *   } else if (Array.isArray(child)) {
   *     for (var i = 0; i < child.length; i++) {
   *       _renderArbitrary(child[i]);
   *     }
   *   } else if (type === "object") {
   *     if (child.__jsxDOMWrapper) {
   *       var func = child.func, args = child.args;
   *       if (args) {
   *         func.apply(this, args);
   *       } else {
   *         func();
   *       }
   *     } else if (String(child) === "[object Object]") {
   *       for (var prop in child) {
   *         if (_hasOwn.call(child, prop)) {
   *           renderArbitrary(child[prop])
   *         }
   *       }
   *     }
   *   }
   * }
   */

  return t.functionExpression(ref, [child], t.blockStatement([t.variableDeclaration("var", [t.variableDeclarator(type, t.unaryExpression("typeof", child))]), t.IfStatement(isTextual(type, child), t.blockStatement([t.expressionStatement((0, _toFunctionCall["default"])((0, _idomMethod["default"])("text", plugin), [child]))]), t.ifStatement(isArray(child), t.blockStatement([t.forStatement(t.variableDeclaration("var", [t.variableDeclarator(i, t.numericLiteral(0))]), t.binaryExpression("<", i, t.memberExpression(child, t.identifier("length"))), t.updateExpression("++", i), t.expressionStatement((0, _toFunctionCall["default"])(ref, [t.memberExpression(child, i, true)])))]), t.ifStatement(isObject(type), t.blockStatement([t.ifStatement(isDOMWrapper(child), t.blockStatement([t.variableDeclaration("var", [t.variableDeclarator(func, t.memberExpression(child, func)), t.variableDeclarator(args, t.memberExpression(child, args))]), t.ifStatement(args, t.blockStatement([t.expressionStatement((0, _toFunctionCall["default"])(t.memberExpression(func, t.identifier("apply")), [t.thisExpression(), args]))]), t.blockStatement([t.expressionStatement((0, _toFunctionCall["default"])(func, []))]))]), t.ifStatement(isPlainObject(child), t.blockStatement([t.forInStatement(t.variableDeclaration("var", [t.variableDeclarator(prop)]), child, t.ifStatement((0, _toFunctionCall["default"])(t.memberExpression(hasOwn, t.identifier("call")), [child, i]), t.expressionStatement((0, _toFunctionCall["default"])(ref, [t.memberExpression(child, i, true)]))))])))]))))]));
}

function injectRenderArbitrary(plugin) {
  return (0, _inject["default"])(plugin, "renderArbitrary", renderArbitraryAST, {
    hasOwn: _hasOwn["default"]
  });
}