"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = injectSpreadAttribute;

var _inject = _interopRequireDefault(require("../inject"));

var _hasOwn = _interopRequireDefault(require("./has-own"));

var _toFunctionCall = _interopRequireDefault(require("../ast/to-function-call"));

var _idomMethod = _interopRequireDefault(require("../idom-method"));

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Iterates over a SpreadAttribute, assigning each property as an attribute
// on the element.
function spreadAttributeAST(plugin, ref, deps) {
  var hasOwn = deps.hasOwn;
  var spread = t.identifier("spread");
  var prop = t.identifier("prop");
  /**
   * function _spreadAttribute(spread) {
   *   for (var prop in spread) {
   *     if (_hasOwn.call(spread, prop)) {
   *       attr(prop, spread[prop]);
   *     }
   *   }
   * }
   */

  return t.functionExpression(ref, [spread], t.blockStatement([t.forInStatement(t.variableDeclaration("var", [t.variableDeclarator(prop)]), spread, t.ifStatement((0, _toFunctionCall["default"])(t.memberExpression(hasOwn, t.identifier("call")), [spread, prop]), t.expressionStatement((0, _toFunctionCall["default"])((0, _idomMethod["default"])("attr", plugin), [prop, t.memberExpression(spread, prop, true)]))))]));
}

function injectSpreadAttribute(plugin) {
  return (0, _inject["default"])(plugin, "spreadAttribute", spreadAttributeAST, {
    hasOwn: _hasOwn["default"]
  });
}